Attribute VB_Name = "Code Base"
Option Compare Text
Option Explicit

Sub PrintReportTags()
    Dim db As Database, dirname As String, i, j, k
    Dim tdef As TableDef, fld As Field
    Dim qdef As QueryDef, ctr As Container
    Dim doc As Document
    
    Set db = CurrentDb
    Set ctr = db.Containers!Reports
    For Each doc In ctr.Documents
        Debug.Print doc.Name, ;
        DoCmd.OpenReport doc.Name, acViewDesign
        Debug.Print Reports(doc.Name).Tag
        DoCmd.Close acReport, doc.Name
    Next doc
End Sub

Function ProduceCodeBase()
    Dim db As Database, dirname As String, i, j, k
    Dim tdef As TableDef, fld As Field
    Dim qdef As QueryDef, ctr As Container
    Dim cb As CommandBar
    Dim doc As Document
    
    dirname = InputBox("Please enter an output directory ...", "Export Code Base", _
        "C:\_temp")
    If dirname = "" Then Exit Function
    If Not DirExists(dirname) Then
        MkDir dirname
    End If
    
    ' "***********  D O C U M E N T S  ***************"
    Open dirname & "\Documents.txt" For Output As #1
    Set db = CurrentDb
    Print #1, "--------------  T A B L E S  ------------------"
    For Each tdef In db.TableDefs
        If (tdef.Attributes And dbSystemObject) = 0 Then Print #1, tdef.Name
    Next tdef
    Print #1,
    Print #1, "--------------  Q U E R I E S  ------------------"
    For Each qdef In db.QueryDefs
        If Left(qdef.Name, 1) <> "~" Then Print #1, qdef.Name
    Next qdef
    Print #1,
    Print #1, "--------------  F O R M S  ------------------"
    Set ctr = db.Containers!Forms
    For Each doc In ctr.Documents
        Print #1, doc.Name
    Next doc
    Print #1,
    Print #1, "--------------  R E P O R T S  ------------------"
    Set ctr = db.Containers!Reports
    For Each doc In ctr.Documents
        Print #1, doc.Name
    Next doc
    Print #1,
    Print #1, "--------------  M O D U L E S  ------------------"
    Set ctr = db.Containers!Modules
    For Each doc In ctr.Documents
        Print #1, doc.Name
    Next doc
    Close #1
    
    ' "***********  T A B L E S  &  Q U E R I E S  ***************"
    Open dirname & "\Tables & Queries.txt" For Output As #1
    For Each tdef In db.TableDefs
        If (tdef.Attributes And dbSystemObject) Then GoTo NextTDef
        Print #1, "-----------------------------"
        Print #1, "Table: "; tdef.Name
        For i = 0 To tdef.Fields.Count - 1
            With tdef.Fields(i)
            If (i Mod 3) = 2 Then
                Print #1, .Name; " - "; .Type
            Else
                Print #1, .Name; " - "; .Type; Tab(((i Mod 3) + 1) * 30);
            End If
            End With
        Next i
        Print #1,: Print #1,: Print #1,
NextTDef:
    Next tdef
    Print #1,: Print #1,
    
    Print #1,
    Print #1, "***********  Q U E R I E S  ***************"
    Print #1,
    For Each qdef In db.QueryDefs
        If Left(qdef.Name, 1) <> "~" Then
            Print #1, "Query: "; qdef.Name
            Print #1, "-----------------------------"
            Print #1, qdef.sql,
            Print #1,: Print #1,
        End If
    Next qdef
    Close #1
    
    Dim cntl As control
    
    ' "***********  F O R M S  ***************"
    Set ctr = db.Containers!Forms
    For Each doc In ctr.Documents
        SaveAsText acForm, doc.Name, dirname & "\Form - " & doc.Name & ".txt"
    Next doc
    
    '***********  R E P O R T S  ***************"
    Set ctr = db.Containers!Reports
    For Each doc In ctr.Documents
        SaveAsText acReport, doc.Name, dirname & "\Report - " & doc.Name & ".txt"
    Next doc
    
    ' ***********  M O D U L E S  ***************"
    Set ctr = db.Containers!Modules
    For Each doc In ctr.Documents
        SaveAsText acModule, doc.Name, dirname & "\Module - " & doc.Name & ".txt"
    Next doc
    MsgBox "Done"
End Function

Function ProduceCodeBase_Old()
    Dim db As Database, dirname As String, i, j, k
    Dim tdef As TableDef, fld As Field
    Dim qdef As QueryDef, ctr As Container
    Dim cb As CommandBar
    Dim doc As Document
    
    dirname = InputBox("Please enter an output directory ...", "Export Code Base", _
        "C:\_temp")
    If dirname = "" Then Exit Function
    If Not DirExists(dirname) Then
        MkDir dirname
    End If
    
    ' "***********  D O C U M E N T S  ***************"
    Open dirname & "\Documents.doc" For Output As #1
    Set db = CurrentDb
    Print #1, "--------------  T A B L E S  ------------------"
    For Each tdef In db.TableDefs
        If (tdef.Attributes And dbSystemObject) = 0 Then Print #1, tdef.Name
    Next tdef
    Print #1,
    Print #1, "--------------  Q U E R I E S  ------------------"
    For Each qdef In db.QueryDefs
        If Left(qdef.Name, 1) <> "~" Then Print #1, qdef.Name
    Next qdef
    Print #1,
    Print #1, "--------------  F O R M S  ------------------"
    Set ctr = db.Containers!Forms
    For Each doc In ctr.Documents
        Print #1, doc.Name
    Next doc
    Print #1,
    Print #1, "--------------  R E P O R T S  ------------------"
    Set ctr = db.Containers!Reports
    For Each doc In ctr.Documents
        Print #1, doc.Name
    Next doc
    Print #1,
    Print #1, "--------------  M O D U L E S  ------------------"
    Set ctr = db.Containers!Modules
    For Each doc In ctr.Documents
        Print #1, doc.Name
    Next doc
    Close #1
    
    ' "***********  T A B L E S  &  Q U E R I E S  ***************"
    Open dirname & "\Tables & Queries.doc" For Output As #1
    For Each tdef In db.TableDefs
        If (tdef.Attributes And dbSystemObject) Then GoTo NextTDef
        Print #1, "-----------------------------"
        Print #1, "Table: "; tdef.Name
        For i = 0 To tdef.Fields.Count - 1
            With tdef.Fields(i)
            If (i Mod 3) = 2 Then
                Print #1, .Name; " - "; .Type
            Else
                Print #1, .Name; " - "; .Type; Tab(((i Mod 3) + 1) * 30);
            End If
            End With
        Next i
        Print #1,: Print #1,: Print #1,
NextTDef:
    Next tdef
    Print #1,: Print #1,
    
    Print #1,
    Print #1, "***********  Q U E R I E S  ***************"
    Print #1,
    For Each qdef In db.QueryDefs
        If Left(qdef.Name, 1) <> "~" Then
            Print #1, "Query: "; qdef.Name
            Print #1, "-----------------------------"
            Print #1, qdef.sql,
            Print #1,: Print #1,
        End If
    Next qdef
    Close #1
    
    Dim cntl As control
    
    ' "***********  F O R M S  ***************"
    Set ctr = db.Containers!Forms
    For Each doc In ctr.Documents
        Open dirname & "\Form - " & doc.Name & ".doc" For Output As #1
        DoCmd.OpenForm doc.Name, acDesign, , , , acHidden
        Print #1,
        Print #1, "RibbonName : " & Forms(doc.Name).RibbonName
        Print #1, "Toolbar : " & Forms(doc.Name).Toolbar
        Print #1, "MenuBar : " & Forms(doc.Name).MenuBar
        Print #1, "ShortcutMenuBar : " & Forms(doc.Name).ShortcutMenuBar
        Print #1, "RecordSource : "
        Print #1, "  "; Forms(doc.Name).RecordSource,
        Print #1,
        Print #1, "Controls : "
        For Each cntl In Forms(doc.Name)
            Print #1, "  "; cntl.Name;
            On Error Resume Next
            Print #1, " | "; cntl.ControlSource;
            Print #1, " | "; cntl.RowSource;
            Print #1, " | "; cntl.SourceObject;
            Print #1,
            On Error GoTo 0
        Next cntl
        If Forms(doc.Name).HasModule Then
            Print #1,
            Print #1, "<<<<<<  CODE >>>>>>": Print #1,
            Print #1, Forms(doc.Name).Module.Lines(1, Forms(doc.Name).Module.CountOfLines)
            Print #1,: Print #1, "<<<<<<  END OF CODE >>>>>>"
            Print #1,
        End If
        DoCmd.Close acForm, doc.Name
        Close #1
    Next doc
    
    '***********  R E P O R T S  ***************"
    Set ctr = db.Containers!Reports
    For Each doc In ctr.Documents
        Open dirname & "\Report - " & doc.Name & ".doc" For Output As #1
        DoCmd.OpenReport doc.Name, acViewDesign
        Print #1,
        Print #1, "RibbonName : " & Reports(doc.Name).RibbonName
        Print #1, "Toolbar : " & Reports(doc.Name).Toolbar
        Print #1, "MenuBar : " & Reports(doc.Name).MenuBar
        Print #1, "ShortcutMenuBar : " & Reports(doc.Name).ShortcutMenuBar
        Print #1, "RecordSource : "
        Print #1, "  "; Reports(doc.Name).RecordSource,
        Print #1,
        Print #1, "Controls : "
        For Each cntl In Reports(doc.Name)
            Print #1, "  "; cntl.Name;
            On Error Resume Next
            Print #1, " | "; cntl.ControlSource;
            Print #1, " | "; cntl.RowSource;
            Print #1, " | "; cntl.SourceObject;
            Print #1,
            On Error GoTo 0
        Next cntl
        If Reports(doc.Name).HasModule Then
            Print #1,
            Print #1, "<<<<<<  CODE >>>>>>": Print #1,
            Print #1, Reports(doc.Name).Module.Lines(1, Reports(doc.Name).Module.CountOfLines)
            Print #1,: Print #1, "<<<<<<  END OF CODE >>>>>>"
            Print #1,
        End If
        DoCmd.Close acReport, doc.Name
        Close #1
    Next doc
    
    ' ***********  M O D U L E S  ***************"
    Set ctr = db.Containers!Modules
    For Each doc In ctr.Documents
        Open dirname & "\Module - " & doc.Name & ".doc" For Output As #1
        DoCmd.OpenModule doc.Name
        Print #1,
        Print #1, Modules(doc.Name).Lines(1, Modules(doc.Name).CountOfLines)
        Print #1,
        DoCmd.Close acModule, doc.Name
        Close #1
    Next doc
    
End Function


Sub testCodeBase()
    DoCmd.TransferText acExportDelim, , "Services", "c:\_temp\Services.txt", True
    
    Application.SaveAsText acTable, "Other Donations", "C:\_temp\Other Donations.txt"
    Application.SaveAsText acTable, "Services", "C:\_temp\Services.txt"
    Application.SaveAsText acQuery, "Marked Cash", "c:\_temp\Marked Cash.txt"
    Application.SaveAsText acForm, "About", "c:\_temp\About.txt"
    Application.SaveAsText acReport, "Service Report", "c:\_temp\Service Report.txt"
    Application.SaveAsText acModule, "Code2", "c:\_temp\Code2.txt"
End Sub


